/* Copyright (c) Damijan Andrejka, Slovenia, 2002.  */
/* It is a program that uses OpenGL graphics library */
/* to draw a cup for white coffee. */
/* The user can input thickness, radius and height of the cup */
/* and rotate the cup with the mouse */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>       
#include <GL/glut.h>

#undef PI 
#define PI 3.14159265358979323846
    
typedef enum {E, SKODELICA} displayLists;

float moving, beginx, beginy;
float newModel = 1;
float r;
float d;
float rv;
float h;
float hv;
float deb;
float delitev=73;
float drn1;
float drn2;
   
   GLfloat angle = -150;  
   GLfloat angle2 = 30;  
   GLfloat angler = 0;
   GLfloat anglef = 0;
   GLfloat angled = 0;
   GLfloat xloc = 0, yloc = 0, zloc = 0;
   GLboolean doubleBuffer = GL_TRUE, iconic = GL_FALSE, keepAspect = GL_FALSE;

   GLfloat lightZeroPosition[] = {0.0, 0.0, 10.0, 0.0};
   GLfloat lightZeroColor[] = {0.8, 1.0, 0.8, 1.0}; 
   GLfloat lightOnePosition[] = {0.0, 10.0, -10.0, 1.0};
   GLfloat lightOneColor[] = {0.6, 0.3, 0.2, 20.0}; 
   GLfloat skinColor[] = {0.1, 1.0, 0.1, 1.0};

   void
   VnosParametrov(void)
  {
   VnosZ:
   printf( "Enter thickness (between 1 and 4):");
   scanf( "%f", &deb);
     if ((deb >= 1)&&(deb <= 4) )
       d = deb;
       else 
     {
       goto VnosZ;
     }
 
   VnosR:
   printf( "Enter radius (between 4 and 15):");
   scanf( "%f", &rv);
     if ((rv >= 4)&&(rv <= 15) )
      r = rv;
       else 
     {
       goto VnosR;
     }

   VnosH:
   printf( "Enter height (between 12 and 32):");
   scanf( "%f", &hv);
     if ((hv >= 12)&&(hv <= 32) )
      h = hv;
       else 
     {
       goto VnosH;
     }
 }

/*Izris modela*/
   void
   makeSKODELICA(void)
  {

   glNewList(SKODELICA, GL_COMPILE);
   glMaterialfv(GL_FRONT, GL_DIFFUSE, skinColor);
  
/*notranje dno '1'*/
   angle = 0;
   glNormal3f(1.0, 1.0, 1.0);
   glBegin(GL_TRIANGLE_FAN);
   glVertex3f(0.0,0.0,-h/2);
   for(angler = 2*PI; angler >= 0; angler -= 2*PI/delitev) 
   {
      glVertex3f(r*cos(angler),r*sin(angler),-h/2);
   }
   
   glEnd(); 
   
/*notranji spodnji radij '2'*/
   angled = 0;
   angler = 0;
   drn1 = 1;
   for (angler=0; angler <= 2*PI; angler+=2*PI/delitev)
    { glRotatef((2*PI/delitev)*180/PI, 0.0, 0.0, 1.0); 

        glNormal3f(1.0, -1.0, 1.0);
        glPushMatrix();
        glTranslatef(r-r/100,0.0,-h/2+drn1);
        glBegin(GL_QUAD_STRIP);
          for(angled = PI/2; angled >= 0; angled -= 2*PI/delitev)
           { 
             glVertex3f(drn1*sin(angled),(r*sin(2*PI/delitev)+(drn1*sin((angled)*2*PI/delitev)))/2,(-drn1*cos(angled)));
             glVertex3f(drn1*sin(angled),-(r*sin(2*PI/delitev)+(drn1*sin((angled)*2*PI/delitev)))/2,(-drn1*cos(angled)));
           } 
     
        glEnd(); 
        glPopMatrix();
    }

/*notranja stena '3'*/
   glNormal3f(-1.0, 1.0, 1.0);
   glBegin(GL_QUAD_STRIP);
   for(angler = 2*PI; angler >= 0; angler -= 2*PI/delitev) 
   {
      glVertex3f((r+drn1)*sin(angler),(r+drn1)*cos(angler),-h/2+drn1-h/200);
      glVertex3f((r+drn1)*sin(angler),(r+drn1)*cos(angler),h/2);
      
   }
   
   glEnd();

/*zgornja zaokrozitev '4'*/
   angled = 0;
   angler = 0;
   for (angler=0; angler <= 2*PI; angler+=2*PI/delitev)
    { glRotatef((2*PI/delitev)*180/PI, 0.0, 0.0, 1.0); 

        glNormal3f(1.0, 0.0, 1.0);
        glPushMatrix();
        glTranslatef(r+drn1+d/2,0.0,h/2-h/200);
        glBegin(GL_QUAD_STRIP);
          for(angled = PI; angled >= 0; angled -= 2*PI/delitev)
           { 
             glVertex3f(-d/2*cos(angled),((r+drn1)*sin(2*PI/delitev)+(d/2*sin((angled+PI/100)*2*PI/delitev)))/2,(d/2*sin(angled)));
             glVertex3f(-d/2*cos(angled),-((r+drn1)*sin(2*PI/delitev)+(d/2*sin((angled+PI/100)*2*PI/delitev)))/2,(d/2*sin(angled)));
           } 
     
        glEnd(); 
        glPopMatrix();
    }

/*zunanja stena '5'*/
   glNormal3f(1.0, 1.0, 1.0);
   glBegin(GL_QUAD_STRIP);
   for(angler = 2*PI; angler >= 0; angler -= 2*PI/delitev) 
   {
      glVertex3f((r+drn1+d)*sin(angler),(r+drn1+d)*cos(angler),-h/2-d);
      glVertex3f((r+drn1+d)*sin(angler),(r+drn1+d)*cos(angler),h/2);
      
   }
   
   glEnd();
   
/*zunanji spodnji radij '6'*/
   angled = 0;
   angler = 0;
   drn2 = 1;
   for (angler=0; angler <= 2*PI; angler+=2*PI/delitev)
    { glRotatef((2*PI/delitev)*180/PI, 0.0, 0.0, 1.0); 

        glNormal3f(1.0, 0.0, 0.0);
        glPushMatrix();
        glTranslatef(r+drn1+d-drn2,0.0,-h/2-d);
        glBegin(GL_QUAD_STRIP);
          for(angled = PI/2; angled >= 0; angled -= 2*PI/delitev)
           { 
             glVertex3f(drn2*sin(angled),((r+drn1+d)*sin(2*PI/delitev)+(drn2*sin((angled+PI/100)*2*PI/delitev)))/2,(-drn2*cos(angled)));
             glVertex3f(drn2*sin(angled),-((r+drn1+d)*sin(2*PI/delitev)+(drn2*sin((angled+PI/100)*2*PI/delitev)))/2,(-drn2*cos(angled)));
           } 
     
        glEnd(); 
        glPopMatrix();
    }
    
/*spodnji rob '7'*/
   glNormal3f(0.0, -1.0, 0.0);
   glBegin(GL_QUAD_STRIP);
   
   for(angler = 2*PI; angler >= 0; angler -= 2*PI/delitev) 
   {
      glVertex3f((r+drn1+d-drn2-d/2-h/200)*cos(angler),(r+drn1+d-drn2-d/2-h/200)*sin(angler),-h/2-d-drn2);
      glVertex3f((r+drn1+d-drn2+h/200)*cos(angler),(r+drn1+d-drn2+h/200)*sin(angler),-h/2-d-drn2);
   }
   
   glEnd(); 
    
/*notranji spodnji radij '8'*/
   angled = 0;
   angler = 0;
   drn2 = 1;
   for (angler=0; angler <= 2*PI; angler+=2*PI/delitev)
    { glRotatef((2*PI/delitev)*180/PI, 0.0, 0.0, 1.0); 

        glNormal3f(1.0, 1.0, 1.0);
        glPushMatrix();
        glTranslatef(r,0.0,-h/2-d-1);
        glBegin(GL_QUAD_STRIP);
          for(angled = PI/2; angled >= 0; angled -= 2*PI/delitev)
           { 
             glVertex3f((drn1+d-1-d/2)*sin(angled),((r+drn1+d)*sin(2*PI/delitev)+(drn2*sin((angled+PI/100)*2*PI/delitev)))/2,(drn2*cos(-angled)));
             glVertex3f((drn1+d-1-d/2)*sin(angled),-((r+drn1+d)*sin(2*PI/delitev)+(drn2*sin((angled+PI/100)*2*PI/delitev)))/2,(drn2*cos(-angled)));
           } 
     
        glEnd(); 
        glPopMatrix();
    }
    

/*zunanje dno '9'*/
   angle = 0;
   glNormal3f(0.0, -1.0, 0.0);
   glBegin(GL_TRIANGLE_FAN);
   glVertex3f(0.0,0.0,-h/2-d);
   for(angler = 2*PI; angler >= 0; angler -= 2*PI/delitev) 
   {
      glVertex3f((r+h/200)*cos(angler),(r+h/200)*sin(angler),-h/2-d);
   }
   
   glEnd(); 
   

/*rocaj '10'*/
   angled = 0;
   angler = 0;
   glTranslatef(r+drn1+8*d/10,0.0,0.0);
   glRotatef(90, 0.0, 1.0, 0.0);
   glRotatef(90, 1.0, 0.0, 0.0);
   glRotatef(-1.0*(2*PI/delitev)*180/PI, 0.0, 0.0, 1.0);
   for (angler=0; angler <= PI; angler+=2*PI/delitev)
    { glRotatef((2*PI/delitev)*180/PI, 0.0, 0.0, 1.0); 

        glNormal3f(1.0, 1.0, 1.0);
        glPushMatrix();
        glTranslatef(3*h/8,0.0,0.0);
        glBegin(GL_QUAD_STRIP);
          for(angled = 2*PI; angled >= 0; angled -= 2*PI/delitev)
           { 
             glVertex3f(1.1*sin(angled),((3*h/8)*sin(2*PI/delitev)+(2.2*sin((angled+PI/100)*2*PI/delitev)))/2,(-2.2*cos(angled)));
             glVertex3f(1.1*sin(angled),-((3*h/8)*sin(2*PI/delitev)+(2.2*sin((angled+PI/100)*2*PI/delitev)))/2,(-2.2*cos(angled)));
           } 
     
        glEnd(); 
        glPopMatrix();
    }

 
  glEndList();
  }

   void
   recalcModelView(void)
  {
   glPopMatrix();
   glPushMatrix();
   glRotatef(angle2, 1.0, 0.0, 0.0);
   glRotatef(angle, 0.0, 1.0, 0.0);
   newModel = 0;
  }

   void
   redraw(void)
  {
   if (newModel)
    recalcModelView();
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glCallList(SKODELICA);
    glutSwapBuffers();
  }

   void
   mouse(int button, int state, int x, int y)
 {
  if (button == GLUT_LEFT_BUTTON && state == GLUT_DOWN) {
    moving = 1;
    beginx = x;
    beginy = y;
  }
  if (button == GLUT_LEFT_BUTTON && state == GLUT_UP) {
    moving = 0;
  }
 } 

   void
   motion(int x, int y)
  {
  if (moving) {
    angle = angle + (x - beginx);
    angle2 = angle2 + (y - beginy);
    beginx = x;
    beginy = y;
    newModel = 1;
    glutPostRedisplay();
  }
} 

   void
   tablet(int x, int y)
  {
   xloc = ((GLfloat) x) / 500 - 4;
   yloc = ((GLfloat) y) / 1000 - 2;
   newModel = 1;
   glutPostRedisplay();
  }

   int xt = 1, yt = 1, zt = 1, xr = 1;

   void
   rotate(int x, int y, int z)
  {
   if (xr) {
     angle += x / 2.0;
     newModel = 1;
     glutPostRedisplay();
   }
  }

   void
   button(int button, int state)
  {
  if (state == GLUT_DOWN) {
    switch (button) {
    case 1:
      xt = yt = zt = xr = 1;
      break;
    case 5:
      xt = 1;
      yt = zt = xr = 0;
      break;
    case 6:
      yt = 1;
      xt = zt = xr = 0;
      break;
    case 7:
      zt = 1;
      xt = yt = xr = 0;
      break;
    case 8:
      xr = 1;
      xt = yt = zt = 0;
      break;
    case 9:
      xloc = yloc = zloc = 0;
      newModel = 1;
      glutPostRedisplay();
      break;
   }
  }
}

   int
   main(int argc, char **argv)
  {
  VnosParametrov();
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH | GLUT_MULTISAMPLE);
  glutInitWindowSize(512, 512); 
  glutCreateWindow("CoffeeCup - Use mouse to rotate");
  glutDisplayFunc(redraw);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutTabletMotionFunc(tablet);
  glutSpaceballRotateFunc(rotate);
  glutSpaceballButtonFunc(button);
  makeSKODELICA();
//  glEnable(GL_CULL_FACE);
  glEnable(GL_DEPTH_TEST);
//  glEnable(GL_NORMALIZE);
  glMatrixMode(GL_PROJECTION);
  gluPerspective(60.0, 1.0, 1.0, 100.0);
  glMatrixMode(GL_MODELVIEW);
  gluLookAt(0.0, 0.0, 50.0,  
    0.0, 0.0, 0.0,     
    0.0, 1.0, 0.);      
  glPushMatrix();       
  glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, 1);
  glLightfv(GL_LIGHT0, GL_POSITION, lightZeroPosition);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightZeroColor);
  glLightf(GL_LIGHT0, GL_CONSTANT_ATTENUATION, 0.1);
  glLightf(GL_LIGHT0, GL_LINEAR_ATTENUATION, 0.05);
  glLightfv(GL_LIGHT1, GL_POSITION, lightOnePosition);
  glLightfv(GL_LIGHT1, GL_DIFFUSE, lightOneColor);
  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHT1);
  glEnable(GL_LIGHTING);
  glutMainLoop();
  return 0;             
}
